力扣hot100(37)栈-有效的括号

核心思想:为什么必须用栈?

一句话:

括号的闭合规则 = 栈的 "后进先出" 规则

后遇到的左括号,必须最先被闭合。 比如 ([)]:

  • 先遇到 (,再遇到 [
  • 接下来遇到 ),应该先闭合最后遇到的 [ ,但这里闭合了 (,所以错误

栈正好完美匹配这个逻辑:

  • 遇到左括号 → 压入栈顶(后遇到的在最上面)
  • 遇到右括号 → 弹出栈顶的左括号,检查是否匹配。

完整解题步骤

  1. 边界预判 :如果字符串长度是奇数,直接返回 false(括号必须成对出现)
  2. 建立映射:用哈希表存储 "右括号 → 对应左括号" 的映射,方便快速查找
  3. 遍历字符串 :
    • 遇到左括号 → 压入栈
    • 遇到右括号:
      • 如果栈为空(没有对应的左括号)→ 返回 false
      • 如果栈顶的左括号和当前右括号不匹配 → 返回 false
      • 如果匹配 → 弹出栈顶
  4. 最终检查 :遍历结束后,如果栈为空,说明所有左括号都匹配成功;否则有剩余左括号没匹配,返回 false
cpp 复制代码
class Solution {
public:
    bool isValid(string s) {
        int  n  = s.size();
        //如果是奇数肯定不成对 直接返回false
        if(n%2 == 1){
            return false;
        }


        //哈希表维护正常的配对 //右括号当键 
        unordered_map<char,char> pairs = {

            {')','('},
            {']','['},
            {'}','{'}

        };

        stack<char> stk;
        //遍历这个s 遇到左括号就入栈 遇到右括号就和栈顶匹配
        for(char ch:s){
            if(pairs.count(ch)){//判断ch这个键存不存在 也就是是不是右括号
                //如果哈希表里有ch当前这个字符

                //如果当前栈为空(那就没有匹配的) 或者栈顶不等于当前元素的另一半
                if(stk.empty()||stk.top()!= pairs[ch]){
                    return false;
                }

                //否则就是匹配上了 那就弹出栈顶
                stk.pop();
                

                
            }
            else{//如果不是右括号 那就入栈
            stk.push(ch);}

            

        }
        return stk.empty(); //最后看看最后的栈是否为空 如果是空说明都匹配了 所以是真的;如果不为空 说明有剩余 说明假的
    }
};
相关推荐
辛苦才能5 小时前
C++ 哈希表深度解析:删除为什么必须打标记,负载因子为什么卡 0.7
开发语言·数据结构·c++·算法
随风爱学习5 小时前
JAVA学习之异常
java
m0_639906945 小时前
HashMap:哈希扰动、扩容源码、红黑树转换、并发问题
java·算法·哈希算法
miller-tsunami5 小时前
STL简介&string相关知识点
开发语言·c++·string
神魔皆以血嗜5 小时前
Java 存储金额
java·后端
半摆烂日常6 小时前
手机表单的左滑操作:触摸事件的处理细节
大数据·开发语言·人工智能·智能手机·https·c#
星夜离尘566 小时前
MATLAB滑动RMS如何接报警:窗口未满和缺样不能当成正常
开发语言·matlab
SL_staff6 小时前
周报越厚问题越拖?用结构化执行机制让周报回归决策价值
java·spring cloud·开源
开开心心就好6 小时前
白天晚上自动调蓝光,护眼工具亮度可调
服务器·开发语言·算法·pdf·ocr·intellij-idea·idea
张张123y6 小时前
后端第十一课:RAG 落地实战(从 0 到 1 接上私有知识库,并设计一个好用的 RAG)
开发语言·人工智能·python·机器学习·fastapi·rag